<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: infusions_include.php
| Author: Hans Kristian Flaatten (Starefossen)
| Co-Author: Robert Gaudyn (Wooya)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

// Sets the value of a setting in the settings_inf table
function set_setting($setting_name, $setting_value, $setting_inf) {
	$set_result = dbquery("SELECT settings_name FROM ".DB_SETTINGS_INF." WHERE settings_name='$setting_name' AND settings_inf='$setting_inf'");
	if (dbrows($set_result)) {
		$up_result = dbquery("UPDATE ".DB_SETTINGS_INF." SET settings_value='$setting_value' WHERE settings_name='$setting_name' AND settings_inf='$setting_inf'");
	} else {
		$in_result = dbquery("INSERT INTO ".DB_SETTINGS_INF." (settings_name, settings_value, settings_inf) VALUES ('$setting_name', '$setting_value', '$setting_inf')");
	}
}

// Get the settings for the infusion from the settings_inf table
function get_settings($setting_inf) {
	$settings_arr = array();
	$set_result = dbquery("SELECT settings_name, settings_value FROM ".DB_SETTINGS_INF." WHERE settings_inf='$setting_inf'");
	while ($set_data = dbarray($set_result)) {
		$settings_arr[$set_data['settings_name']] = $set_data['settings_value'];
	}
	return $settings_arr;
}

// Send PM to a user
function send_pm($to, $from, $subject, $message, $smileys = "y") {
	global $settings;

	include LOCALE.LOCALESET."messages.php";
	require_once INCLUDES."sendmail_include.php";
	require_once INCLUDES."flood_include.php";

	$msg_settings = dbarray(dbquery("SELECT pm_inbox, pm_email_notify FROM ".DB_MESSAGES_OPTIONS." WHERE user_id='0'"));
	$error = 0;
	
	if (!flood_control("message_datestamp", DB_MESSAGES, "message_from='$from'")) {
		$result = dbquery(
			"SELECT u.user_id, u.user_name, u.user_email, mo.pm_email_notify, COUNT(message_id) as message_count FROM ".DB_USERS." u
			LEFT JOIN ".DB_MESSAGES_OPTIONS." mo USING(user_id)
			LEFT JOIN ".DB_MESSAGES." ON message_to=u.user_id AND message_folder='0'
			WHERE u.user_id='$to' GROUP BY u.user_id"
		);
		if (dbrows($result)) {
			$data = dbarray($result);
			$result = dbquery("SELECT user_id, user_name FROM ".DB_USERS." WHERE user_id='$from'");
			if (dbrows($result)) {
				$userdata = dbarray($result);
				if ($to != $from) {
					if ($msg_settings['pm_inbox'] == "0" || ($data['message_count'] + 1) <= $msg_settings['pm_inbox']) {
						$result = dbquery("INSERT INTO ".DB_MESSAGES." (message_to, message_from, message_subject, message_message, message_smileys, message_read, message_datestamp, message_folder) VALUES('".$data['user_id']."','".$userdata['user_id']."','".$subject."','".$message."','".$smileys."','0','".time()."','0')");
						$message_content = str_replace("[SUBJECT]", $subject, $locale['626']);
						$message_content = str_replace("[USER]", $userdata['user_name'], $message_content);
						$send_email = isset($data['pm_email_notify']) ? $data['pm_email_notify'] : $msg_settings['pm_email_notify'];
						if ($send_email == "1") { sendemail($data['user_name'], $data['user_email'], $settings['siteusername'], $settings['siteemail'], $locale['625'], $data['user_name'].$message_content); }
					} else {
						// Inbox is full
						$error = 1;
					}
				} else {
					// Reciever and sender are the same user
					$error = 2;
				}
			} else {
				// Sender does not exist in DB
				$error = 3;
			}
		} else {
			// Reciever does not exist in DB
			$error = 4;
		}
	} else {
		// Floodcontrol exceeded
		$error = 5;
	}
	return $error;
}

// Upload file function
function upload_file(
	$source_file, $target_file, $target_folder = DOWNLOADS, $valid_ext = ".zip|.rar|.tar|.bz2|.z7", 
	$max_size = "15000", $query = "", $debug = false) {
	if ($debug) {
		$upload_file = array(
			"source_file" => $source_file, "source_size" => $file['size'], "source_ext" => "", "target_file" => $target_file, 
			"target_folder" => $target_folder, "valid_ext" => $valid_ext, "max_size" => $max_size, "query" => $query,
			"error" => 0
		);
	} else {
		$upload_file = array("error" => 0);
	}
	if (is_uploaded_file($_FILES[$source_file]['tmp_name'])) {
		$valid_ext = explode("|", $valid_ext);
		$file = $_FILES[$source_file];
		$file_name = str_replace(" ", "_", strtolower(substr($file['name'], 0, strrpos($file['name'], "."))));
		$file_ext = strtolower(strrchr($file['name'],"."));
		$file_dest = $target_folder;
		if ($debug) { $upload_file['source_ext'] = $file_ext; }
		if (!preg_match("/^[-0-9A-Z_\.\[\]]+$/i", $file_name)) {
			// Invalid file name
			$upload_file['error'] = 1;
		} elseif ($file['size'] > $max_size){
			// Invalid file size
			$upload_file['error'] = 2;
		} elseif (!in_array($file_ext, $valid_ext)) {
			// Invalid file extension
			$upload_file['error'] = 3;
		} elseif (file_exists($target_folder.$target_file)) {
			// File already exists
			$upload_file['error'] = 4;
		} else {
			move_uploaded_file($file['tmp_name'], $target_folder.$target_file);
			chmod($target_folder.$target_file, 0644);
			if ($query) {
				if (!dbquery($query)) {
					// Invalid query string
					$upload_file['error'] = 5;
					unlink($target_folder.$target_file);
				}
			}
		}
	} else {
		// Invalid uploaded file
		$upload_file['error'] = 6;
	}
	if (!$debug) { return $upload_file['error']; } else { return $upload_file; }
}

// Upload image function
function upload_image(
	$source_image, $target_image, $target_folder = IMAGES, $target_width = "400", $target_height = "300",
	$valid_ext = "jpg|jpeg|png|gif", $max_size = "150000", 
	$thumb = true, $thumb_folder = IMAGES, $thumb_name = "", $thumb_width = "100", $thumb_height = "100",
	$query = ""
) {

}

// Download file from server
function download_file($file) {
	require_once INCLUDES."class.httpdownload.php";
	
	ob_end_clean();
	$object = new httpdownload;
	$object->set_byfile($file);
	$object->use_resume = true;
	$object->download();
	exit;
}

?>